/*
TASK: MAXI
LANG: C
*/
#include <stdio.h>

int dx[] = { -1 , 0 , 0 , 1 };
int dy[] = { 0 , -1 , 1 , 0 };

int n,m;
int a[16][16];

void read() {
    scanf ("%d%d",&n,&m);
    int i,j;
    
    for (i=1;i<=n;i++)
        for (j=1;j<=m;j++)
            scanf ("%d",&a[i][j]);
}

int isok ( int a , int b , int c , int d ) {
    return a>=1&&a<=n
        &&
        b>=1&&b<=m
        &&
        c>=1&&c<=n
        &&
        d>=1&&d<=m;
}

int max ( int a , int b ) {
    return (a>b)?a:b;
}

void solve() {
    int i,j,k1,k2;
    int x1,y1,x2,y2;
    int ans = 0;
    
    for (i=1;i<=n;i++)
        for (j=1;j<=m;j++) {
            for (k1=0;k1<4;k1++)
                for (k2=k1+1;k2<4;k2++) {
                    x1 = i + dx[k1];
                    y1 = j + dy[k1];
                    x2 = i + dx[k2];
                    y2 = j + dy[k2];
                    
                    if ( isok(x1,y1,x2,y2) )
                        ans = max ( ans , a[i][j] + a[x1][y1] + a[x2][y2] );
                }
        }
            
    printf ("%d\n",ans);
}

int main() {
    read();
    solve();
    
    return 0;
}
