/*
TASK: rebus
LANG: C++
*/
#include <cstdio>
#include <string>
#include <sstream>
#include <algorithm>
using namespace std;

string a,b,c;

void read() {
    char ch;
    
    while ( scanf ("%c",&ch) != -1 ) {
        if ( ch == '+' ) break;
        a += ch;
    }
    
    while ( scanf ("%c",&ch) != -1 ) {
        if ( ch == '=' ) break;
        b += ch;
    }
    
    while ( scanf ("%c",&ch) != -1 ) {
        //printf ("u%ci  %d\n",ch,(ch=='\n'));
        if ( ch == '\n' ) break;
        c += ch;
    }
        
    //printf ("!%s!\n!%s!\n!%s!\n",a.c_str(),b.c_str(),c.c_str());
}

int is ( char ch ) {
    return (a[0] == ch&&(int)a.size()>1) || (b[0] == ch&&(int)b.size()>1) || (c[0] == ch&&(int)c.size()>1);
}

int get ( char ch , int a , int b , int c ) {
    if ( ch == 'A' ) return a;
    if ( ch == 'B' ) return b;
    return c;
}

int check ( int x , int y , int z ) {
    int sz1 = (int)a.size();
    int sz2 = (int)b.size();
    int sz3 = (int)c.size();
    int i;
    long long res1,res2,res3;
    
    res1 = 0;
    res2 = 0;
    res3 = 0;
    
    for (i=0;i<sz1;i++)
        res1 = res1*10 + get ( a[i] , x , y , z );
    for (i=0;i<sz2;i++)
        res2 = res2*10 + get ( b[i] , x , y , z );
    for (i=0;i<sz3;i++)
        res3 = res3*10 + get ( c[i] , x , y , z );
    
    if ( (res1 + res2) == res3 ) {
        printf ("%lld+%lld=%lld\n",res1,res2,res3);
        
        return 1;
    }
    
    return 0;
}

void solve() {
    int i,j,k;
    int l1,l2,l3;
    
    l1 = is('A');
    l2 = is('B');
    l3 = is('C');
    
    for (i=l1;i<=9;i++)
        for (j=l2;j<=9;j++)
            for (k=l3;k<=9;k++)
                if ( check(i,j,k) )
                    return ;
}

int main() {
    read();
    solve();
    
    return 0;    
}

